> For the complete documentation index, see [llms.txt](https://docs.defisaver.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.defisaver.com/actions/spark/sparksupply.md).

# SparkSupply

### Description

Supply a token to an Spark market

> **Notes**
>
> User deposits tokens to the Spark protocol

### Action ID

`0x92e0c47c`

### SDK Action

```ts
const sparkSupplyAction = new dfs.actions.spark.SparkSupplyAction(
    useDefaultMarket,
    market,
    amount,
    from,
    tokenAddress,
    assetId,
    enableAsColl,
    useOnBehalf,
    onBehalf
);
```

### Action Type

`STANDARD_ACTION`

### Input Parameters

```solidity
    /// @param amount Amount of tokens to supply
    /// @param from Address to pull the supply tokens from
    /// @param assetId The id of the token to be supplied
    /// @param enableAsColl Whether to enable the asset as collateral
    /// @param useDefaultMarket Whether to use the default market
    /// @param useOnBehalf Whether to supply on behalf of another address
    /// @param market Address of the market to supply to
    struct Params {
        uint256 amount;
        address from;
        uint16 assetId;
        bool enableAsColl;
        bool useDefaultMarket;
        bool useOnBehalf;
        address market;
        address onBehalf;
    }
```

### Return Value

```solidity
return bytes32(supplyAmount);
```

### Events and Logs

```solidity
emit ActionEvent("SparkSupply", logData);
logger.logActionDirectEvent("SparkSupply", logData);
bytes memory logData = abi.encode(params);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.defisaver.com/actions/spark/sparksupply.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
